Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4504)
@@ -1205,69 +1270,48 @@
             SendCmd "volume shading specularExp $specularExp"
         }
-        light2side {
-            set val $_settings($this-light2side)
+        "-light2side" {
+            set val $_settings($what)
             SendCmd "volume shading light2side $val"
         }
-        transp {
-            set val $_settings($this-transp)
-            set sval [expr { 0.01 * double($val) }]
-            SendCmd "volume shading opacity $sval"
-        }
-        opacity {
-            set val $_settings($this-opacity)
-            set sval [expr { 0.01 * double($val) }]
-            foreach tf [array names _activeTfs] {
-                set _settings($this-$tf-opacity) $sval
-                set _activeTfs($tf) 0
-            }
-            updatetransferfuncs
-        }
-        thickness {
-            if { [array names _activeTfs] > 0 } {
-                set val $_settings($this-thickness)
-                # Scale values between 0.00001 and 0.01000
-                set sval [expr {0.0001*double($val)}]
-                foreach tf [array names _activeTfs] {
-                    set _settings($this-$tf-thickness) $sval
-                    set _activeTfs($tf) 0
-                }
-                updatetransferfuncs
-            }
-        }
-        "outline" {
-            SendCmd "volume outline state $_settings($this-outline)"
-        }
-        "isosurface" {
-            SendCmd "volume shading isosurface $_settings($this-isosurface)"
-        }
-        "colormap" {
-            set color [$itk_component(colormap) value]
-            set _settings(colormap) $color
-            # Only set the colormap on the first volume. Ignore the others.
-            #ResetColormap $color
-        }
-        "grid" {
-            SendCmd "grid visible $_settings($this-grid)"
-        }
-        "axes" {
-            SendCmd "axis visible $_settings($this-axes)"
-        }
-        "legend" {
-            if { $_settings($this-legend) } {
-                blt::table $itk_component(plotarea) \
-                    0,0 $itk_component(3dview) -fill both \
-                    1,0 $itk_component(legend) -fill x 
-                blt::table configure $itk_component(plotarea) r1 -resize none
-            } else {
-                blt::table forget $itk_component(legend)
-            }
-        }
-        "volume" {
-            set datasets [CurrentDatasets -cutplanes] 
-            SendCmd "volume data state $_settings($this-volume) $datasets"
-        }
-        "xcutplane" - "ycutplane" - "zcutplane" {
-            set axis [string range $what 0 0]
-            set bool $_settings($this-$what)
+        "-volumeopacity" {
+            set _settings($what) [expr $_widget($what) * 0.01]
+            set _settings($_current${what}) $_settings($what)
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume shading opacity $_settings($what) $tag"
+            }
+            #updateTransferFunctions
+        }
+        "-outlinevisible" {
+            SendCmd "volume outline state $_settings($what)"
+        }
+        "-thickness" {
+            set val $_settings($what)
+            set _settings($_current${what}) $val
+            updateTransferFunctions
+        }
+        "-volume" {
+            # This is the global volume visibility control.  It controls the
+            # visibility of all the all volumes.  Whenever it's changed, you
+            # have to synchronize each of the local controls (see below) with
+            # this.
+            set datasets [CurrentDatasets] 
+            set bool $_settings($what)
+            SendCmd "volume data state $bool $datasets"
+            foreach cname $_componentsList {
+                set _settings($cname-volumevisible) $bool
+            }
+            set _settings(-volumevisible) $bool
+        }
+        "-volumevisible" {
+            # This is the component specific control.  It changes the 
+            # visibility of only the current component.
+            set _settings($_current${what}) $_settings($what)
+            foreach tag [GetDatasetsWithComponent $_current] {
+                SendCmd "volume data state $_settings($what) $tag"
+            }
+        }
+        "-xcutplanevisible" - "-ycutplanevisible" - "-zcutplanevisible" {
+            set axis [string range $what 1 1]
+            set bool $_settings($what)
             set datasets [CurrentDatasets -cutplanes] 
             set tag [lindex $datasets 0]
@@ -1299,19 +1343,13 @@
     set w [expr {$_width-20}]
     set h [expr {[winfo height $itk_component(legend)]-20-$lineht}]
-    if {$w > 0 && $h > 0 && [array names _activeTfs] > 0 && $_first != "" } {
-        set tag [lindex [CurrentDatasets] 0]
-        if { [info exists _dataset2style($tag)] } {
-            SendCmd "legend $_dataset2style($tag) $w $h"
-        }
-    } else {
-        # Can't do this as this will remove the items associated with the
-        # isomarkers.
-        
-        #$itk_component(legend) delete all
-    }
-}
-
-#
-# NameTransferFunc --
+    if {$w > 0 && $h > 0 && $_first != "" } {
+        if { [info exists _cname2transferFunction($_current)] } {
+            SendCmd "legend $_current $w $h"
+        }
+    }
+}
+
+#
+# NameTransferFunction --
 #
 #       Creates a transfer function name based on the <style> settings in the
@@ -1321,45 +1359,43 @@
 #       server parses the 3D data and sends back the limits via ReceiveData.]
 #
-#       FIXME: The current way we generate transfer-function names completely
-#              ignores the -markers option.  The problem is that we are forced
-#              to compute the name from an increasing complex set of values:
-#              color, levels, marker, opacity.  I think we're stuck doing it
-#              now.
-#
-itcl::body Rappture::NanovisViewer::NameTransferFunc { dataobj cname } {
+itcl::body Rappture::NanovisViewer::NameTransferFunction { dataobj cname } {
     array set styles {
         -color BCGYR
         -levels 6
-        -opacity 1.0
         -markers ""
     }
     set tag $dataobj-$cname
     array set styles [lindex [$dataobj components -style $cname] 0]
-    set tf "$styles(-color):$styles(-levels):$styles(-opacity)"
-    set _dataset2style($tag) $tf
-    lappend _style2datasets($tf) $tag
-    return $tf
-}
-
-#
-# ComputeTransferFunc --
-#
-#   Computes and sends the transfer function to the render server.  It's
-#   assumed that the volume data limits are known and that the global
-#   transfer-functions slider values have been set up.  Both parts are
-#   needed to compute the relative value (location) of the marker, and
-#   the alpha map of the transfer function.
-#
-itcl::body Rappture::NanovisViewer::ComputeTransferFunc { tf } {
-    array set styles {
-        -color BCGYR
-        -levels 6
-        -opacity 1.0
-        -markers ""
-        -alphamap ""
-    }
-
-    foreach {dataobj cname} [split [lindex $_style2datasets($tf) 0] -] break
-    array set styles [lindex [$dataobj components -style $cname] 0]
+    if { ![info exists _cname2transferFunction($cname)] } {
+        # Get the colormap right now, since it doesn't change with marker
+        # changes.
+        set cmap [ColorsToColormap $styles(-color)]
+        set wmap [list 0.0 0.0 1.0 1.0]
+        set _cname2transferFunction($cname) [list $cmap $wmap]
+        SendCmd [list transfunc define $cname $cmap $wmap]
+    }
+    SendCmd "volume shading transfunc $cname $tag"
+    if { ![info exists _transferFunctionEditors($cname)] } {
+        set _transferFunctionEditors($cname) \
+            [Rappture::TransferFunctionEditor ::\#auto $itk_component(legend) \
+                 $cname \
+                 -command [itcl::code $this updateTransferFunctions]]
+    }
+    set _dataset2style($tag) $cname
+    lappend _style2datasets($cname) $tag
+    return $cname
+}
+
+#
+# ComputeTransferFunction --
+#
+#       Computes and sends the transfer function to the render server.  It's
+#       assumed that the volume data limits are known and that the global
+#       transfer-functions slider values have been set up.  Both parts are
+#       needed to compute the relative value (location) of the marker, and
+#       the alpha map of the transfer function.
+#
+itcl::body Rappture::NanovisViewer::ComputeTransferFunction { cname } {
+    foreach {cmap wmap} $_cname2transferFunction($cname) break
 
     # We have to parse the style attributes for a volume using this
@@ -1369,86 +1405,45 @@
     # of the volumes (the first in the list) using the transfer-function as a
     # reference.
-    #
-    # FIXME: The current way we generate transfer-function names completely 
-    #        ignores the -markers option.  The problem is that we are forced 
-    #        to compute the name from an increasing complex set of values: 
-    #        color, levels, marker, opacity.  I think the cow's out of the
-    #        barn on this one.
-
-    if { ![info exists _isomarkers($tf)] } {
+    if { ![info exists _parsedFunction($cname)] } {
+        array set styles {
+            -color BCGYR
+            -levels 6
+            -markers ""
+        }
+        # Accumulate the style from all the datasets using it.
+        foreach tag [GetDatasetsWithComponent $cname] {
+            foreach {dataobj cname} [split [lindex $tag 0] -] break
+            array set styles [lindex [$dataobj components -style $cname] 0]
+        }
+        eval $_transferFunctionEditors($cname) limits $_limits($cname)
         # Have to defer creation of isomarkers until we have data limits
         if { [info exists styles(-markers)] &&
              [llength $styles(-markers)] > 0 } {
-            ParseMarkersOption $tf $styles(-markers)
+            ParseMarkersOption $cname $styles(-markers)
         } else {
-            ParseLevelsOption $tf $styles(-levels)
-        }
-        if { $styles(-alphamap) != "" } {
-            set _alphamap($cname) $styles(-alphamap)
-        }
-    }
-    set cmap [ColorsToColormap $styles(-color)]
-    set tag $this-$tf
-    if { ![info exists _settings($tag-opacity)] } {
-        set _settings($tag-opacity) $styles(-opacity)
-    }
-    set max 1.0 ;#$_settings($tag-opacity)
-
-    set isovalues {}
-    foreach m $_isomarkers($tf) {
-        lappend isovalues [$m relval]
-    }
-    # Sort the isovalues
-    set isovalues [lsort -real $isovalues]
-
-    if { ![info exists _settings($tag-thickness)]} {
-        set _settings($tag-thickness) 0.005
-    }
-    set delta $_settings($tag-thickness)
-
-    set first [lindex $isovalues 0]
-    set last [lindex $isovalues end]
-    set wmap ""
-    if { $first == "" || $first != 0.0 } {
-        lappend wmap 0.0 0.0
-    }
-    foreach x $isovalues {
-        set x1 [expr {$x-$delta-0.00001}]
-        set x2 [expr {$x-$delta}]
-        set x3 [expr {$x+$delta}]
-        set x4 [expr {$x+$delta+0.00001}]
-        if { $x1 < 0.0 } {
-            set x1 0.0
-        } elseif { $x1 > 1.0 } {
-            set x1 1.0
-        }
-        if { $x2 < 0.0 } {
-            set x2 0.0
-        } elseif { $x2 > 1.0 } {
-            set x2 1.0
-        }
-        if { $x3 < 0.0 } {
-            set x3 0.0
-        } elseif { $x3 > 1.0 } {
-            set x3 1.0
-        }
-        if { $x4 < 0.0 } {
-            set x4 0.0
-        } elseif { $x4 > 1.0 } {
-            set x4 1.0
-        }
-        # add spikes in the middle
-        lappend wmap $x1 0.0
-        lappend wmap $x2 $max
-        lappend wmap $x3 $max
-        lappend wmap $x4 0.0
-    }
-    if { $last == "" || $last != 1.0 } {
-        lappend wmap 1.0 0.0
-    }
-    if { [info exists _alphamap($cname)] } {
-        set wmap $_alphamap($cname)
-    }
-    SendCmd [list transfunc define $tf $cmap $wmap]
+            ParseLevelsOption $cname $styles(-levels)
+        }
+        
+    }
+    set wmap [ComputeAlphamap $cname]
+    set _cname2transferFunction($cname) [list $cmap $wmap]
+    SendCmd [list transfunc define $cname $cmap $wmap]
+}
+
+itcl::body Rappture::NanovisViewer::AddNewMarker { x y } {
+    if { ![info exists _transferFunctionEditors($_current)] } {
+        continue
+    }
+    # Add a new marker to the current transfer function
+    $_transferFunctionEditors($_current) newMarker $x $y normal
+    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
+}
+
+itcl::body Rappture::NanovisViewer::RemoveMarker { x y } {
+    if { ![info exists _transferFunctionEditors($_current)] } {
+        continue
+    }
+    # Add a new marker to the current transfer function
+    $_transferFunctionEditors($_current) deleteMarker $x $y 
 }
 
@@ -1498,21 +1493,20 @@
 # marker is a relative value from 0.0 to 1.0.
 #
-itcl::body Rappture::NanovisViewer::ParseLevelsOption { tf levels } {
+itcl::body Rappture::NanovisViewer::ParseLevelsOption { cname levels } {
     set c $itk_component(legend)
+    set list {}
     regsub -all "," $levels " " levels
     if {[string is int $levels]} {
         for {set i 1} { $i <= $levels } {incr i} {
-            set x [expr {double($i)/($levels+1)}]
-            set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $m relval $x
-            lappend _isomarkers($tf) $m 
+            lappend list [expr {double($i)/($levels+1)}]
         }
     } else {
         foreach x $levels {
-            set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $m relval $x
-            lappend _isomarkers($tf) $m 
-        }
-    }
+            lappend list $x
+        }
+    }
+    set _parsedFunction($cname) 1
+    $_transferFunctionEditors($cname) addMarkers $list
+    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
 }
 
@@ -1529,22 +1523,22 @@
 #       not be seen.
 #
-itcl::body Rappture::NanovisViewer::ParseMarkersOption { tf markers } {
+itcl::body Rappture::NanovisViewer::ParseMarkersOption { cname markers } {
     set c $itk_component(legend)
+    set list {}
+    foreach { min max } $_limits($cname) break
     regsub -all "," $markers " " markers
     foreach marker $markers {
         set n [scan $marker "%g%s" value suffix]
         if { $n == 2 && $suffix == "%" } {
-            # ${n}% : Set relative value. 
-            set value [expr {$value * 0.01}]
-            set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $m relval $value
-            lappend _isomarkers($tf) $m
+            # $n% : Set relative value (0..1). 
+            lappend list [expr {$value * 0.01}]
         } else {
-            # ${n} : Set absolute value.
-            set m [Rappture::IsoMarker \#auto $c $this $tf]
-            $m absval $value
-            lappend _isomarkers($tf) $m
-        }
-    }
+            # $n : absolute value, compute relative
+            lappend list  [expr {(double($value)-$min)/($max-$min)]}
+        }
+    }
+    set _parsedFunction($cname) 1
+    $_transferFunctionEditors($cname) addMarkers $list
+    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
 }
 
@@ -1552,82 +1546,25 @@
 # USAGE: UndateTransferFuncs 
 # ----------------------------------------------------------------------
-itcl::body Rappture::NanovisViewer::updatetransferfuncs {} {
+itcl::body Rappture::NanovisViewer::updateTransferFunctions {} {
     $_dispatcher event -idle !send_transfunc
 }
 
-itcl::body Rappture::NanovisViewer::AddIsoMarker { x y } {
-    if { $_first == "" } {
-        error "active transfer function isn't set"
-    }
-    set tag [lindex [CurrentDatasets] 0]
-    set tf $_dataset2style($tag)
-    set c $itk_component(legend)
-    set m [Rappture::IsoMarker \#auto $c $this $tf]
-    set w [winfo width $c]
-    $m relval [expr {double($x-10)/($w-20)}]
-    lappend _isomarkers($tf) $m
-    updatetransferfuncs
-    return 1
-}
-
-itcl::body Rappture::NanovisViewer::rmdupmarker { marker x } {
-    set tf [$marker transferfunc]
-    set bool 0
-    if { [info exists _isomarkers($tf)] } {
-        set list {}
-        set marker [namespace tail $marker]
-        foreach m $_isomarkers($tf) {
-            set sx [$m screenpos]
-            if { $m != $marker } {
-                if { $x >= ($sx-3) && $x <= ($sx+3) } {
-                    $marker relval [$m relval]
-                    itcl::delete object $m
-                    bell
-                    set bool 1
-                    continue
-                }
-            }
-            lappend list $m
-        }
-        set _isomarkers($tf) $list
-        updatetransferfuncs
-    }
-    return $bool
-}
-
-itcl::body Rappture::NanovisViewer::overmarker { marker x } {
-    set tf [$marker transferfunc]
-    if { [info exists _isomarkers($tf)] } {
-        set marker [namespace tail $marker]
-        foreach m $_isomarkers($tf) {
-            set sx [$m screenpos]
-            if { $m != $marker } {
-                set bool [expr { $x >= ($sx-3) && $x <= ($sx+3) }]
-                $m activate $bool
-            }
-        }
-    }
-    return ""
-}
-
-itcl::body Rappture::NanovisViewer::limits { tf } {
+itcl::body Rappture::NanovisViewer::limits { cname } {
     set _limits(min) 0.0
     set _limits(max) 1.0
-    if { ![info exists _style2datasets($tf)] } {
+    if { ![info exists _style2datasets($cname)] } {
         return [array get _limits]
     }
     set min ""; set max ""
-    foreach tag $_style2datasets($tf) {
-        if { ![info exists _serverDatasets($tag)] } {
+    foreach tag [GetDatasetsWithComponent $cname] {
+        if { ![info exists _limits($tag)] } {
             continue
         }
-        if { ![info exists _limits($tag-min)] } {
-            continue
-        }
-        if { $min == "" || $min > $_limits($tag-min) } {
-            set min $_limits($tag-min)
-        }
-        if { $max == "" || $max < $_limits($tag-max) } {
-            set max $_limits($tag-max)
+        foreach {amin amax} $_limits($tag) break
+        if { $min == "" || $min > $amin } {
+            set min $amin
+        }
+        if { $max == "" || $max < $amax } {
+            set max $amax
         }
     }
@@ -1638,21 +1575,9 @@
         set _limits(max) $max
     }
-    return [array get _limits]
+    return [list $_limits(min) $_limits(max)]
 }
 
 
 itcl::body Rappture::NanovisViewer::BuildViewTab {} {
-    foreach { key value } {
-        grid            0
-        axes            1
-        outline         0
-        volume          1
-        legend          1
-        particles       1
-        lic             1
-    } {
-        set _settings($this-$key) $value
-    }
-
     set fg [option get $itk_component(hull) font Font]
     #set bfg [option get $itk_component(hull) boldFont Font]
@@ -1663,39 +1588,39 @@
     $inner configure -borderwidth 4
 
-    set ::Rappture::NanovisViewer::_settings($this-isosurface) 0
+    set ::Rappture::NanovisViewer::_settings(-isosurfaceshading) 0
     checkbutton $inner.isosurface \
         -text "Isosurface shading" \
-        -variable [itcl::scope _settings($this-isosurface)] \
-        -command [itcl::code $this AdjustSetting isosurface] \
+        -variable [itcl::scope _settings(-isosurfaceshading)] \
+        -command [itcl::code $this AdjustSetting -isosurfaceshading] \
         -font "Arial 9"
 
     checkbutton $inner.axes \
         -text "Axes" \
-        -variable [itcl::scope _settings($this-axes)] \
-        -command [itcl::code $this AdjustSetting axes] \
+        -variable [itcl::scope _settings(-axesvisible)] \
+        -command [itcl::code $this AdjustSetting -axesvisible] \
         -font "Arial 9"
 
     checkbutton $inner.grid \
         -text "Grid" \
-        -variable [itcl::scope _settings($this-grid)] \
-        -command [itcl::code $this AdjustSetting grid] \
+        -variable [itcl::scope _settings(-gridvisible)] \
+        -command [itcl::code $this AdjustSetting -gridvisible] \
         -font "Arial 9"
 
     checkbutton $inner.outline \
         -text "Outline" \
-        -variable [itcl::scope _settings($this-outline)] \
-        -command [itcl::code $this AdjustSetting outline] \
+        -variable [itcl::scope _settings(-outlinevisible)] \
+        -command [itcl::code $this AdjustSetting -outlinevisible] \
         -font "Arial 9"
 
     checkbutton $inner.legend \
         -text "Legend" \
-        -variable [itcl::scope _settings($this-legend)] \
-        -command [itcl::code $this AdjustSetting legend] \
+        -variable [itcl::scope _settings(-legendvisible)] \
+        -command [itcl::code $this AdjustSetting -legendvisible] \
         -font "Arial 9"
 
     checkbutton $inner.volume \
         -text "Volume" \
-        -variable [itcl::scope _settings($this-volume)] \
-        -command [itcl::code $this AdjustSetting volume] \
+        -variable [itcl::scope _settings(-volume)] \
+        -command [itcl::code $this AdjustSetting -volume] \
         -font "Arial 9"
 
@@ -1715,14 +1640,4 @@
 
 itcl::body Rappture::NanovisViewer::BuildVolumeTab {} {
-    foreach { key value } {
-        light2side      1
-        light           40
-        transp          50
-        opacity         100
-        thickness       350
-    } {
-        set _settings($this-$key) $value
-    }
-
     set inner [$itk_component(main) insert end \
         -title "Volume Settings" \
@@ -1730,44 +1645,41 @@
     $inner configure -borderwidth 4
 
+    set font [option get $itk_component(hull) font Font]
     set fg [option get $itk_component(hull) font Font]
     #set bfg [option get $itk_component(hull) boldFont Font]
 
     checkbutton $inner.vol -text "Show volume" -font $fg \
-        -variable [itcl::scope _settings($this-volume)] \
-        -command [itcl::code $this AdjustSetting volume]
+        -variable [itcl::scope _settings(-volumevisible)] \
+        -command [itcl::code $this AdjustSetting -volumevisible]
     label $inner.shading -text "Shading:" -font $fg
 
     checkbutton $inner.light2side -text "Two-sided lighting" -font $fg \
-        -variable [itcl::scope _settings($this-light2side)] \
-        -command [itcl::code $this AdjustSetting light2side]
+        -variable [itcl::scope _settings(-light2side)] \
+        -command [itcl::code $this AdjustSetting -light2side]
 
     label $inner.dim -text "Glow" -font $fg
     ::scale $inner.light -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings($this-light)] \
+        -variable [itcl::scope _settings(-light)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting light]
+        -showvalue off -command [itcl::code $this AdjustSetting -light]
     label $inner.bright -text "Surface" -font $fg
 
+    # Opacity
     label $inner.fog -text "Clear" -font $fg
     ::scale $inner.transp -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings($this-transp)] \
+        -variable [itcl::scope _widget(-volumeopacity)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting transp]
+        -showvalue off -command [itcl::code $this AdjustSetting -volumeopacity]
     label $inner.plastic -text "Opaque" -font $fg
 
-    label $inner.clear -text "Clear" -font $fg
-    ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings($this-opacity)] \
-        -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting opacity]
-    label $inner.opaque -text "Opaque" -font $fg
-
+    # Tooth thickness
     label $inner.thin -text "Thin" -font $fg
     ::scale $inner.thickness -from 0 -to 1000 -orient horizontal \
-        -variable [itcl::scope _settings($this-thickness)] \
+        -variable [itcl::scope _settings(-thickness)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting thickness]
+        -showvalue off -command [itcl::code $this AdjustSetting -thickness]
     label $inner.thick -text "Thick" -font $fg
 
+    # Colormap 
     label $inner.colormap_l -text "Colormap" -font "Arial 9" 
     itk_component add colormap {
@@ -1778,8 +1690,19 @@
     $itk_component(colormap) value "BCGYR"
     bind $inner.colormap <<Value>> \
-        [itcl::code $this AdjustSetting colormap]
+        [itcl::code $this AdjustSetting -colormap]
+    $itk_component(colormap) value "default"
+    set _settings(-colormap) "default"
+
+    # Component
+    label $inner.volcomponents_l -text "Component" -font $font
+    itk_component add volcomponents {
+        Rappture::Combobox $inner.volcomponents -editable no
+    }
+    bind $inner.volcomponents <<Value>> \
+        [itcl::code $this AdjustSetting -current]
 
     blt::table $inner \
-        0,0 $inner.vol -cspan 4 -anchor w -pady 2 \
+        0,0 $inner.volcomponents_l -anchor e -cspan 2 \
+        0,2 $inner.volcomponents             -cspan 3 -fill x \
         1,0 $inner.shading -cspan 4 -anchor w -pady {10 2} \
         2,0 $inner.light2side -cspan 4 -anchor w -pady 2 \
@@ -1804,4 +1727,10 @@
     $inner configure -borderwidth 4
 
+    checkbutton $inner.visible \
+        -text "Show Cutplanes" \
+        -variable [itcl::scope _settings(-cutplanesvisible)] \
+        -command [itcl::code $this AdjustSetting -cutplanesvisible] \
+        -font "Arial 9"
+    
     # X-value slicer...
     itk_component add xCutButton {
@@ -1809,9 +1738,10 @@
             -onimage [Rappture::icon x-cutplane] \
             -offimage [Rappture::icon x-cutplane] \
-            -command [itcl::code $this AdjustSetting xcutplane] \
-            -variable [itcl::scope _settings($this-xcutplane)]
+            -command [itcl::code $this AdjustSetting -xcutplanevisible] \
+            -variable [itcl::scope _settings(-xcutplanevisible)]
     }
     Rappture::Tooltip::for $itk_component(xCutButton) \
         "Toggle the X cut plane on/off"
+    $itk_component(xCutButton) select
 
     itk_component add xCutScale {
@@ -1820,5 +1750,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move x] \
-            -variable [itcl::scope _settings($this-xcutposition)]
+            -variable [itcl::scope _settings(-xcutplaneposition)]
     } {
         usual
@@ -1836,9 +1766,10 @@
             -onimage [Rappture::icon y-cutplane] \
             -offimage [Rappture::icon y-cutplane] \
-            -command [itcl::code $this AdjustSetting ycutplane] \
-            -variable [itcl::scope _settings($this-ycutplane)]
+            -command [itcl::code $this AdjustSetting -ycutplanevisible] \
+            -variable [itcl::scope _settings(-ycutplanevisible)]
     }
     Rappture::Tooltip::for $itk_component(yCutButton) \
         "Toggle the Y cut plane on/off"
+    $itk_component(yCutButton) select
 
     itk_component add yCutScale {
@@ -1847,5 +1778,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move y] \
-            -variable [itcl::scope _settings($this-ycutposition)]
+            -variable [itcl::scope _settings(-ycutplaneposition)]
     } {
         usual
@@ -1863,9 +1794,10 @@
             -onimage [Rappture::icon z-cutplane] \
             -offimage [Rappture::icon z-cutplane] \
-            -command [itcl::code $this AdjustSetting zcutplane] \
-            -variable [itcl::scope _settings($this-zcutplane)]
+            -command [itcl::code $this AdjustSetting -zcutplanevisible] \
+            -variable [itcl::scope _settings(-zcutplanevisible)]
     }
     Rappture::Tooltip::for $itk_component(zCutButton) \
         "Toggle the Z cut plane on/off"
+    $itk_component(zCutButton) select
 
     itk_component add zCutScale {
@@ -1874,5 +1806,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move z] \
-            -variable [itcl::scope _settings($this-zcutposition)]
+            -variable [itcl::scope _settings(-zcutplaneposition)]
     } {
         usual
@@ -1881,5 +1813,4 @@
     $itk_component(zCutScale) set 50
     $itk_component(zCutScale) configure -state disabled
-    #$itk_component(zCutScale) configure -state disabled
     Rappture::Tooltip::for $itk_component(zCutScale) \
         "@[itcl::code $this SlicerTip z]"
@@ -1923,9 +1854,9 @@
         label $inner.${tag}label -text $tag -font "Arial 9"
         entry $inner.${tag} -font "Arial 9"  -bg white \
-            -textvariable [itcl::scope _settings($this-$tag)]
+            -textvariable [itcl::scope _settings(-$tag)]
         bind $inner.${tag} <Return> \
-            [itcl::code $this camera set ${tag}]
+            [itcl::code $this camera set -${tag}]
         bind $inner.${tag} <KP_Enter> \
-            [itcl::code $this camera set ${tag}]
+            [itcl::code $this camera set -${tag}]
         blt::table $inner \
             $row,0 $inner.${tag}label -anchor e -pady 2 \
@@ -1976,7 +1907,4 @@
 itcl::body Rappture::NanovisViewer::SlicerTip {axis} {
     set val [$itk_component(${axis}CutScale) get]
-#    set val [expr {0.01*($val-50)
-#        *($_limits(${axis}max)-$_limits(${axis}min))
-#          + 0.5*($_limits(${axis}max)+$_limits(${axis}min))}]
     return "Move the [string toupper $axis] cut plane.\nCurrently:  $axis = $val%"
 }
@@ -1999,5 +1927,5 @@
 }
 
-itcl::body Rappture::NanovisViewer::EventuallyResizeLegend {} {
+itcl::body Rappture::NanovisViewer::EventuallyRedrawLegend {} {
     if { !$_resizeLegendPending } {
         $_dispatcher event -idle !legend
@@ -2014,25 +1942,25 @@
         }
         "set" {
-            set who [lindex $args 0]
-            set x $_settings($this-$who)
+            set what [lindex $args 0]
+            set x $_settings($what)
             set code [catch { string is double $x } result]
             if { $code != 0 || !$result } {
-                set _settings($this-$who) $_view($who)
+                set _settings($what) $_view($what)
                 return
             }
-            switch -- $who {
-                "xpan" - "ypan" {
-                    set _view($who) $_settings($this-$who)
+            switch -- $what {
+                "-xpan" - "-ypan" {
+                    set _view($what) $_settings($what)
                     PanCamera
                 }
-                "qx" - "qy" - "qz" - "qw" {
-                    set _view($who) $_settings($this-$who)
-                    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+                "-qx" - "-qy" - "-qz" - "-qw" {
+                    set _view($what) $_settings($what)
+                    set q [ViewToQuaternion]
                     $_arcball quaternion $q
                     SendCmd "camera orient $q"
                 }
-                "zoom" {
-                    set _view($who) $_settings($this-$who)
-                    SendCmd "camera zoom $_view(zoom)"
+                "-zoom" {
+                    set _view($what) $_settings($what)
+                    SendCmd "camera zoom $_view($what)"
                 }
             }
